/**
 * User: 
 * Date: 13-2-62:22
 * Description:
 * Project:
 */
KISSY.add("scrollbar",function(S){
    var $ = S.all, D = S.DOM;

    function Scrollbar(container,config,fn){
        if(!(this instanceof Scrollbar)){
            return new Scrollbar(container,config,fn);
        }
        var defaultConfig = {
            stepLen : 120,
            hasArrow : true,
            scroll : "y",
            fetchData : false,
            invisibleCls : "sbhidden",
            margin: [0, 0, 0 , 0]
        };

        this.container = container;
        this.config = S.merge(defaultConfig,config);
        this.fn = fn;

        this._init();
    }

    S.augment(Scrollbar,{

        inited : false,

        enabled : false,

        startPos : 0,

        //ʼ
        _init : function(){
            var self = this;
            if(!self.container || (typeof self.container !== 'string')) return;

            self.con = $(self.container);

            if(self.con && !self.con.length) return;
            self.inner = self.config.inner ? $(self.config.inner) : $(self.con.children()[0]);

            if(self.config.scroll.toUpperCase() === 'Y'){
                self.unit = 'outerHeight';
//                self.unit = 'innerHeight';
                self.scroll = 'Y';
            }else{
                self.unit = 'outerWidth';
//                self.unit = 'innerWidth';
                self.scroll = 'X';
            }

            self._reset();
        },

        _reset : function(){
            var self = this;
            if(self._enabled()){
                self._render();
            }else{
                if(self.bar && self.bar.length){
                    self.bar.addClass(self.config.invisibleCls);
                    self.inner.css('top',0);
                }
                self.enabled = false;
            }
        },

        //ڲжǷҪʾ
        _enabled : function(){
            var self = this,
                unit = self.unit;
            self.conUnit = self.con[unit]();
            self.innerUnit = self.inner[unit]();
            return self.innerUnit > self.conUnit;
        },

        //Ⱦ
        _render : function(){
            var self = this,
                config = self.config,
                arrowable = !!config.hasArrow,
                con = self.con,
                inner = self.inner,
                unit = self.unit,
                conUnit = self.conUnit,
                innerUnit = self.innerUnit,
                bar, track, handle,tc,mc,
                barUnit, trackUnit, handleUnit,innerHandle,
                hw = self.scroll === 'Y' ? 'height' : 'width',
                xy = self.scroll === 'Y' ? 'y' : 'x',
                margin = config.margin,
                m = margin[0] + 'px ' + margin[1] + 'px ' + margin[2] + 'px ' + margin[3] + 'px';

            if(arrowable){
                var arrowLT, arrowRB;
            }

            if(self.inited){
                bar = self.bar;
                track = self.track;
                handle = self.handle;
                if(arrowable){
                    arrowLT = self.arrowLT;
                    arrowRB = self.arrowRB;
                }
            }else{
                var temp = '';
                bar = D.create('<div class="scrollbar-' + xy + ' J_bar"></div>');
                if(self.scroll === 'Y'){
                    track = '<p class="track-' + xy + ' J_track"><span class="handle-' + xy + ' J_handle"><s class="tc"></s><b class="mc"></b><s class="bc"></s></span></p>';
                }else{
                    track = '<p class="track-' + xy + ' J_track"><span class="track-bg"><span class="handle-' + xy + ' J_handle"><s class="tc"></s><b class="mc"></b><s class="bc"></s></span></span></p>';
                }
                if(arrowable){
                    arrowLT = '<s class="arr-' + xy + ' J_arrLT"></s>';
                    arrowRB = '<s class="arr-' + xy + ' J_arrRB"></s>';
                }else{
                    arrowLT = arrowRB = '';
                }

                temp = arrowLT + track + arrowRB;

                D.html(bar, temp);
                con.append(bar);

                bar = self.bar = $(bar);
                track = self.track = $('.J_track', bar);
                handle = self.handle = $('.J_handle', bar);

                tc = self.tc = $('.tc', bar);
                mc = self.mc = $('.mc', bar);
                if(arrowable){
                    arrowLT = self.arrowLT = $('.J_arrLT', bar);
                    arrowRB = self.arrowRB = $('.J_arrRB', bar);
                }
                self.inited = true;
                self._eventBindings();
            }
            trackUnit = arrowable ? conUnit - (arrowLT[unit]()*2) : conUnit;
            if(xy == 'x'){
                trackUnit = trackUnit - margin[1] - margin[3];
            }else if(xy == 'y'){
                trackUnit = trackUnit - margin[0] - margin[2];
            }
            handleUnit = trackUnit * conUnit / innerUnit;
            innerHandle = handleUnit - self.tc[hw]()*2;

            con.css({
                position : 'relative'
            });
            inner.css({
                position : 'relative'
                ,top : 0
            });
            handle.css({
                position : 'relative',
				top: 0
            });
            if(self.scroll === 'Y'){
                bar.css({
                    position : 'absolute',
                    right : 1,
                    top : 0
                });
            }else{
                bar.css({
                    position : 'absolute',
                    bottom : 6,
                    left : 0,
                    margin: m
                });
            }
            track[hw](trackUnit);
            handle[hw](handleUnit);
            self.mc[hw](innerHandle);
            bar.removeClass(config.invisibleCls);
            self.enabled = true;
        },

        //¼
        _eventBindings : function(){
            var self = this,
                config = self.config,
                stepLen = config.stepLen,
                arrowable = !!config.hasArrow,
                mousewheel = !S.UA.gecko ? 'mousewheel' : 'DOMMouseScroll',
                handle = self.handle,
                track = self.track;


            if(self.scroll === 'Y'){
                self.con.on(mousewheel,function(evt){
                    if(!self.enabled) return;
                    var duration = evt.wheelDelta ? evt.wheelDelta/120 : (-evt.detail/3);
                    self._scroll(duration*stepLen);
                })
            }
            if(arrowable){
                self.arrowLT.on('click',function(){
                    self._scroll(stepLen);
                });

                self.arrowRB.on('click',function(){
                    self._scroll(-stepLen);
                });
            }

            track.on('click',function(evt){
                var target = evt.target || evt.srcElement;

                if(D.hasClass(D.parent(target),'J_handle')) return;
                var handleUnit,
                    handleStartPos,
                    moveDistance,
                    reflectDistance;
                if(self.scroll === 'Y'){
                    handleUnit = handle.height();
                    handleStartPos = handle.offset().top;
                    moveDistance = evt.pageY - handleUnit - parseInt(handleStartPos, 10);
                    reflectDistance = moveDistance / track.height() * self.innerUnit;
                }else{
                    handleUnit = handle.width();
                    handleStartPos = handle.offset().left;
                    moveDistance = evt.pageX - handleUnit - parseInt(handleStartPos, 10);
                    reflectDistance = moveDistance / track.width() * self.innerUnit;
                }

                self._scroll(-reflectDistance);
            });

            handle.on('mousedown',function(evt){
                var drag = 0,
                    html = $('html');
                if(self.scroll === 'Y'){
                    drag = evt.pageY;
                }else{
                    drag = evt.pageX;
                }

                html.on('dragstart selectstart',function(){
                    return false;
                });

                html.on('mousemove',function(evt){
                    var reflectDistance = 0;
                    if(self.scroll === 'Y'){
                        reflectDistance = ((evt.pageY - drag) / track.height()) * self.innerUnit;
                        drag = evt.pageY;
                    }else{
                        reflectDistance = ((evt.pageX - drag) / track.width()) * self.innerUnit;
                        drag = evt.pageX;
                    }
                    self._scroll(-reflectDistance);
                });

                html.on('mouseup mouseleave',function(){
                    html.detach('dragstart selectstart mousemove mouseup mouseleave')
                })
            });
        },

        //λ
        _scroll : function(dur, p){
            var self = this,
                startPos = self.startPos,
                inner = self.inner,
                innerUnit = self.innerUnit,
                conUnit = self.conUnit,
                maxDur = innerUnit - conUnit - startPos,
                track = self.track,
                handle = self.handle,
                handlePos;

            if(!self.enabled) return false;

            if(dur > 0){ //Ϲ
                dur = dur > startPos ? -startPos : -dur;
            }else{//¹
                dur = -dur < maxDur ? -dur : maxDur;
            }
            if(p || p == 0){
                self.startPos = startPos = -p;
            }else{
                self.startPos = startPos = parseInt((startPos + dur), 10);
            }


            self._fetchData(maxDur);

            if(self.scroll === 'Y'){
                handlePos = track.height() * (startPos / innerUnit);
                handle.css({
                    top : handlePos
                });
                inner.css({
                    top: -startPos
                });
            }else{
                handlePos = track.width() * (startPos / innerUnit);
                handle.css({
                    left : handlePos
                });
                inner.css({
                    left: -startPos
                });
            }
        },

        _scrollByElement : function(el){
            var self = this,
                offsetTop = el.offset().top;
            self._scroll('',-offsetTop+76);
        },

        _fetchData : function(m){
            var self = this;
            if(self.config.fetchData){
                if(m == 0){
                    try{
                        self.fn();
                    }catch(e){

                    }
                }
            }
        },

        scrollToTop : function(){
            var self = this;
            setTimeout(function(){
                self._reset();
                self._scroll('',0);
            },100);
        },

        //ù
        reset : function(el){
            var self = this;
            setTimeout(function(){
                self._reset();
                (el && el.length) && self._scrollByElement(el);
            },100);
        }

    });

    return Scrollbar;
});